@Conditions =
  TEAM_PREVIEW             : 1
  RATED_BATTLE             : 2
  PBV_1000                 : 3
  TIMED_BATTLE             : 4
  SLEEP_CLAUSE             : 5
  SPECIES_CLAUSE           : 6
  EVASION_CLAUSE           : 7
  OHKO_CLAUSE              : 8
  UNRELEASED_BAN           : 9
  PRANKSTER_SWAGGER_CLAUSE : 10
  PBV_500                  : 11
  VISIBLE_TEAM             : 12

@SelectableConditions = [
  @Conditions.VISIBLE_TEAM
  @Conditions.TIMED_BATTLE
  @Conditions.SLEEP_CLAUSE
  @Conditions.EVASION_CLAUSE
  @Conditions.SPECIES_CLAUSE
  @Conditions.PRANKSTER_SWAGGER_CLAUSE
  @Conditions.OHKO_CLAUSE
  @Conditions.UNRELEASED_BAN
]

@HumanizedConditions =
  en:
    VISIBLE_TEAM   : "Visible Teams"
    TEAM_PREVIEW   : "Team Preview"
    SLEEP_CLAUSE   : "Sleep Clause"
    RATED_BATTLE   : "Rated Battle"
    TIMED_BATTLE   : "Timed Battle"
    SPECIES_CLAUSE : "Species Clause"
    EVASION_CLAUSE : "Evasion Clause"
    OHKO_CLAUSE    : "One-Hit KO Clause"
    UNRELEASED_BAN : "Unreleased Ban"
    PRANKSTER_SWAGGER_CLAUSE : "Prankster + Swagger Clause"

@Formats =
  insur1000:
    humanName:  'Insurgence 1000'
    generation: 'in'
    conditions: [ @Conditions.PBV_1000, @Conditions.TEAM_PREVIEW ]
  xy1000:
    humanName:  '1,000 PBV XY'
    generation: 'xy'
    conditions: [ @Conditions.PBV_1000, @Conditions.TEAM_PREVIEW ]
  xy500:
    humanName:  '500 PBV XY'
    generation: 'xy'
    conditions: [ @Conditions.PBV_500, @Conditions.TEAM_PREVIEW ]

@DEFAULT_FORMAT = 'insur1000'

@tiers =
 PA:
   humanName: "Pathetic"
   tierRank: 0
 LC:
   humanName: "Little Cup"
   tierRank: 1
 PU:
   humanName: "Poorly Used"
   tierRank: 2
 NU:
   humanName: "Never Used"
   tierRank: 3
 RU:
   humanName: "Rarely Used"
   tierRank: 4
 UU:
   humanName: "Under Used"
   tierRank: 5
 OU:
   humanName: "Over Used"
   tierRank: 6
 Uber:
   humanName: "Ubers"
   tierRank: 7
 AG:
   humanName: "Anything Goes"
   tierRank: 8